unit PCUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GIFImage, StdCtrls, ExtCtrls, ComCtrls, Menus, Registry, ShellAPI;

type
  TForm1 = class(TForm)
    ConvListView: TListView;
    MainMenu1: TMainMenu;
    Picture1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    Convert1: TMenuItem;
    Convertall1: TMenuItem;
    OpenPicDialog: TOpenDialog;
    Addconversion1: TMenuItem;
    N1: TMenuItem;
    ConfigPanel: TPanel;
    ColorPanel: TPanel;
    StatusPanel: TPanel;
    ColImage: TImage;
    StatusLabel: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    XSizeLabel: TLabel;
    YSizeLabel: TLabel;
    HeaderLabel: TLabel;
    OverlayLayerCB: TCheckBox;
    SpritePrioCB: TCheckBox;
    Timer1: TTimer;
    ReverseFontCB: TCheckBox;
    ConvListPopup: TPopupMenu;
    Resetcolorassignments1: TMenuItem;
    N3: TMenuItem;
    Assignalternatefontfile1: TMenuItem;
    Clearalternatefontfine1: TMenuItem;
    OpenFontDialog: TOpenDialog;
    FirstChar: TMenuItem;
    N000000001: TMenuItem;
    N010101011: TMenuItem;
    N101010101: TMenuItem;
    N111111111: TMenuItem;
    Nodefaultfirstchar1: TMenuItem;
    N5: TMenuItem;
    RegisterPC4filetypeinregistry1: TMenuItem;
    UnregisterPC4filetype1: TMenuItem;
    Palette1: TMenuItem;
    Defaultpalette11: TMenuItem;
    Defaultpalette21: TMenuItem;
    TrackBar1: TTrackBar;
    ColorLabel: TLabel;
    Resetcolortolerance1: TMenuItem;
    N6: TMenuItem;
    Deleteconversion1: TMenuItem;
    ColorPopupMenu: TPopupMenu;
    ColorSelect: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Load1Click(Sender: TObject);
    procedure ConvListViewClick(Sender: TObject);
    procedure Addconversion1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ConvListViewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure OverlayLayerCBClick(Sender: TObject);
    procedure SpritePrioCBClick(Sender: TObject);
    procedure Convertall1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ReverseFontCBClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ConvListViewContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Resetcolorassignments1Click(Sender: TObject);
    procedure Assignalternatefontfile1Click(Sender: TObject);
    procedure Clearalternatefontfine1Click(Sender: TObject);
    procedure Nodefaultfirstchar1Click(Sender: TObject);
    procedure RegisterPC4filetypeinregistry1Click(Sender: TObject);
    procedure UnregisterPC4filetype1Click(Sender: TObject);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure TrackBar1Change(Sender: TObject);
    procedure Defaultpalette11Click(Sender: TObject);
    procedure Defaultpalette21Click(Sender: TObject);
    procedure Resetcolortolerance1Click(Sender: TObject);
    procedure Deleteconversion1Click(Sender: TObject);
    procedure ColorSelectClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure UpdateConvItem(Var l : TListItem);
Procedure AssignPalette;


var
  Form1: TForm1;
  PicName            : String;
  PicNameNoExt       : String;
  PicPath            : String;
  PicWidth           : Integer;
  PicHeight          : Integer;

  Converting         : Boolean;


Const MaxPicSize = 4000;
      AvailColors = $7fff; // 15 bit


Type ConvPtrType = ^ConvType;

     ConvType = Record
                  ConvType     : Integer;
                  Suffix       : String[50];
                  FirstChar    : Byte;
                  __fill1      : Array[1..100] Of Byte;      // Moved fontfile, should be 0 as it has not been used yet
                  XStart       : Integer;
                  YStart       : Integer;
                  Width        : Integer;
                  Height       : Integer;
                  ColTypes     : Array[0..15] Of Byte;
                  Overlay      : Boolean;
                  SpritePrio   : Boolean;
                  ReverseFont  : Boolean;
                  __Fill       : Array[0..66] Of Byte;
                  FontFile     : String[250];
                End;

     ConfigType = Record
                    Red, Green, Blue        : Array[0..15] Of Integer;
                    Tolerance               : Integer;
                    __Fill                  : Array[0..827] Of Byte;
                  End;


Var CurrentConvItem    : TListItem;
    CurrentPtr         : ConvPtrType;

    Pic                : Array[0..MaxPicSize, 0..MaxPicSize] Of Word;
    Pic2               : Array[0..MaxPicSize, 0..MaxPicSize] Of Integer;
    Overlay            : Array[0..MaxPicSize, 0..MaxPicSize] Of Boolean;

    Config             : ConfigType;

    Red, Green, Blue   : Array[0..15] Of Integer;
    PaletteNo          : Integer;

    ColIndex           : Array[0..AvailColors] Of Byte;


Const MaxTypes = 7;       // Kind of conversions

      AppTitle = 'Picture Converter 4 by Walt of Bonzai';

      TypeWidth        : Array[1..MaxTypes] Of Integer = (8, 8, 24, 24, 8, 8, 48);
      TypeHeight       : Array[1..MaxTypes] Of Integer = (8, 8, 21, 21, 8, 8, 21);
      TypePixelW       : Array[1..MaxTypes] Of Integer = (1, 1,  1,  1, 1, 1,  2);

      Red1     : Array[0..15] Of Integer = (0,   255, 126, 110, 127, 92 , 51,  203, 133, 80,  180, 74,  117, 163, 112, 163);
      Green1   : Array[0..15] Of Integer = (0,   255, 53,  183, 59,  160, 39,  215, 83,  60,  107, 74,  117, 231, 100, 163);
      Blue1    : Array[0..15] Of Integer = (0,   255, 43,  193, 166, 53,  153, 101, 28,  0,   97,  74,  117, 124, 214, 163);


implementation

uses PCUnit2, PCUnit3, PCUnit4;

{$R *.dfm}

Type ScanLineType = Array[0..2047] of word;

     ScanLinePtrType = ^ScanLineType;


Const Red2     : Array[0..15] Of Integer = (0,   255, 146, 132, 147, 114, 72,  213, 153, 103, 193, 96,  138, 179, 134, 179);
      Green2   : Array[0..15] Of Integer = (0,   255, 74,  197, 81,  177, 58,  223, 105, 82,  129, 96,  138, 236, 122, 179);
      Blue2    : Array[0..15] Of Integer = (0,   255, 64,  204, 182, 75,  170, 124, 45,  0,   120, 96,  138, 145, 222, 179);


Var ColPosArr          : Array[1..MaxTypes, 1..15] Of String;
    ColLabels          : Array[0..15] Of TLabel;

    ColorCount         : Integer;

Procedure FixupMenu;
Var ConvSel : Boolean;
    ch      : Integer;

Begin
  ConvSel:=(Form1.ConvListView.SelCount>0);

  Form1.Deleteconversion1.Enabled:=ConvSel;

  Form1.Convertall1.Enabled:=(Form1.ConvListView.Items.Count>0);
  Form1.Addconversion1.Enabled:=(PicName<>'');

  ch:=Form1.ConvListView.Height+15;
  If PicName<>'' Then ch:=ch+Form1.StatusPanel.Height+7;
  If Form1.ConvListView.SelCount>0 Then ch:=ch+Form1.ConfigPanel.Height+7;
  Form1.ClientHeight:=ch;

  Form1.Save1.Enabled:=Form1.Addconversion1.Enabled;
End;


Procedure UpdateConvItem(Var l : TListItem);
Var P                 : ConvPtrType;

Begin
  If l<>NIL Then Begin
    P:=l.Data;
    If P<>NIL Then Begin
      l.Caption:=P^.Suffix;
      l.SubItems[0]:=Form2.TypeComboBox.Items[P^.ConvType];
      l.SubItems[1]:=IntTostr(P^.XStart)+','+IntToSTr(P^.YStart);
      l.SubItems[2]:=IntToStr(p^.Width)+' x '+IntToStr(P^.Height);
      l.SubItems[3]:=P^.FontFile;
    End;
  End;
End;


Procedure AssignPalette;
Var rd, gd, bd        : Integer;
    mrd, mgd, mbd     : Integer;
    r, g, b           : Integer;
    i, p              : Integer;
    fp                : Integer;
    x, y              : Integer;
    mtot              : Integer;
    l                 : TLabel;
    ColsFound         : Integer;
    ColsUsed          : Array[0..15] Of Boolean;

Begin
  For x:=0 To 15 Do Begin
    If PaletteNo=1 Then Begin
      Red[x]:=Red1[x];
      Green[x]:=Green1[x];
      Blue[x]:=Blue1[x];
    End;

    If PaletteNo=2 Then Begin
      Red[x]:=Red2[x];
      Green[x]:=Green2[x];
      Blue[x]:=Blue2[x];
    End;
  End;

  FillChar(ColIndex, SizeOf(ColIndex), #255);
  For x:=0 To PicWidth-1 Do For y:=0 To PicHeight-1 Do ColIndex[Pic[x, y]]:=254;
  ColorCount:=0;
  For y:=0 To AvailColors Do If ColIndex[y]=254 Then Inc(ColorCount);

  For x:=0 To 255 Do for y:=0 to 15 do Form1.ColImage.Canvas.Pixels[x, y]:=Red1[x Div 16]+256*Green1[x Div 16]+65536*Blue1[x Div 16];
  Form1.ColImage.Canvas.Pen.Color:=$404040;
  For y:=16 To 31 Do Begin
    Form1.ColImage.Canvas.MoveTo(0, y);
    Form1.ColImage.Canvas.LineTo(256, y);
  End;
  For x:=0 To 15 Do For y:=5 To 10 Do Begin
    Form1.ColImage.Canvas.Pixels[x*16+y, 16+y]:=clWhite;
    Form1.ColImage.Canvas.Pixels[x*16+15-y, 16+y]:=clWhite;
  End;

  FillChar(ColsUsed, SizeOf(ColsUsed), #0);

  For p:=0 To 15 Do Begin
    l:=ColLabels[p];
    l.Visible:=False;
    l.Color:=Red1[p]+$100*Green1[p]+$10000*Blue1[p];
    l.Font.Color:=0;
    If Red[p]+Green[p]+Blue[p]<500 Then l.Font.Color:=clWhite;

    mrd:=100;
    mgd:=100;
    mbd:=100;
    mtot:=300;
    fp:=-1;

    ColsFound:=0;

    For i:=0 To AvailColors Do Begin
      If ColIndex[i]=254 Then Begin // Found unassigned color
        r:=i Div 1024;
        g:=(i And 1023) Div 32;
        b:=(i And 31);

        r:=(r*8)+4;
        g:=(g*8)+4;
        b:=(b*8)+4;

        rd:=Abs(Red[p]-r);
        gd:=Abs(Green[p]-g);
        bd:=Abs(Blue[p]-b);

        If (rd<=mrd) Or (gd<=mgd) Or (bd<=mbd) Then Begin // Nearest match found
          If (rd+gd+bd)<mtot Then Begin
            mtot:=rd+gd+bd;
            mrd:=rd;
            mgd:=gd;
            mbd:=bd;
            fp:=i;
          End;
        End;
      End;
    End;

    If fp<>-1 Then Begin
      If mtot<Config.Tolerance Then Begin // ensure a good match when not having all 16 colors in source image
        ColIndex[fp]:=p;
        for x:=0 to 15 do for y:=0 to 15 do Form1.ColImage.Canvas.Pixels[x+p*16, y+16]:=(fp and 31)*8*65536+((fp and 1023) div 32)*8*256+((fp div 1024)*8);
        ColsUsed[p]:=True;
      End;
    End;
  End;

  ColsFound:=0;
  For r:=0 To 15 Do If ColsUsed[r] Then Inc(ColsFound);
  Form1.ColorLabel.Caption:=IntToStr(ColorCount)+' colors used.'#13+IntToStr(ColsFound)+' found.';

  Form1.ConvListViewClick(NIL);
End;

Procedure SetupColorPanel;
Var col      : Integer;
    l        : TLabel;
    x, y     : Integer;

Begin
  For y:=1 To MaxTypes Do Begin
    For x:=2 To 15 Do ColPosArr[y, x]:='';
    ColPosArr[y, 1]:='Background';
  End;

  ColPosArr[1, 2]:='Foreground';

  ColPosArr[2, 2]:='Multicolor 1 (01)';
  ColPosArr[2, 3]:='Multicolor 2 (10)';
  ColPosArr[2, 4]:='Char color (11)';

  ColPosArr[3, 1]:='-';
  ColPosArr[3, 2]:='Foreground';

  ColPosArr[4, 1]:='-';
  ColPosArr[4, 2]:='Multicolor 1 (01)';
  ColPosArr[4, 3]:='Sprite color (10)';
  ColPosArr[4, 4]:='Multicolor 2 (11)';

  ColPosArr[5, 1]:='Automatic';
  ColPosArr[5, 2]:='Preferred background';
  ColPosArr[5, 3]:='Preferred foreground';
  ColPosArr[5, 4]:='Fixed background';
  ColPosArr[5, 5]:='Fixed foreground';

  ColPosArr[6, 1]:='Automatic';
  ColPosArr[6, 2]:='Background';
  ColPosArr[6, 3]:='Preferred 01 (Attr. upper)';
  ColPosArr[6, 4]:='Preferred 10 (Attr. lower)';
  ColPosArr[6, 5]:='Preferred 11 (D800)';
  ColPosArr[6, 6]:='Fixed 01 (Attr. upper)';
  ColPosArr[6, 7]:='Fixed 10 (Attr. lower)';
  ColPosArr[6, 8]:='Fixed 11 (D800)';

  ColPosArr[7, 1]:='-';
  ColPosArr[7, 2]:='Foreground even';
  ColPosArr[7, 3]:='Foreground odd';
  ColPosArr[7, 4]:='Foreground even or odd';
  ColPosArr[7, 5]:='Foreground even and odd';

  Form1.ColorPanel.Color:=$604040;

  For col:=0 To 15 Do Begin
    l:=TLabel.Create(Form1);
    ColLabels[col]:=l;
    l.Width:=248;
    l.Height:=31;
    l.Left:=3+249*(col Div 8);
    l.AutoSize:=False;
    l.Alignment:=taCenter;
    l.Parent:=Form1.ColorPanel;
    l.Top:=(col And 7)*32+3;
    l.ParentFont:=False;
    l.Font.Size:=16;
    l.Font.name:='Bahnschrift';
    l.Tag:=col;
    l.OnMouseDown:=Form1.Label1MouseDown;
  End;
End;


procedure TForm1.FormCreate(Sender: TObject);
Var i : Integer;

begin
  PaletteNo:=1;
  Converting:=False;
  FillChar(Config, SizeOf(Config), #0);
  Config.Tolerance:=60;
  TrackBar1.Position:=Config.Tolerance;

  Form1.Caption:=AppTitle;
  i:=SizeOf(ConvType);
  If i<>512 Then Form1.Caption:='!!!! ConvType is '+IntToStr(i)+' - not 512 bytes !!!!';
  i:=SizeOf(ConfigType);
  If i<>1024 Then Form1.Caption:='!!!! ConfigType is '+IntToStr(i)+' - not 1024 bytes !!!!';

  PicName:='';
  SetupColorPanel;
  ColorPanel.BorderStyle:=bsNone;

  FixupMenu;

  DragAcceptFiles(Self.Handle, True);

  Timer1.Enabled:=True;
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

Var l        : TLabel;
    r        : Integer;

begin
  If Sender IS TLabel Then If CurrentPtr<>NIL Then Begin
    l:=Sender AS TLabel;
    ColorPopupMenu.Tag:=l.Tag;

    For r:=0 To ColorPopupMenu.Items.Count-1 Do ColorPopupMenu.Items[r].Checked:=False;
    ColorPopupMenu.Items[CurrentPtr^.ColTypes[l.Tag]-1].Checked:=True;
    
    If CurrentPtr^.ConvType=2 Then Begin // Multicolor char check
      ColorPopupMenu.Items[0].Enabled:=True;
      ColorPopupMenu.Items[3].Enabled:=True;
      If l.Tag>7 Then Begin // Color 8-15
        ColorPopupMenu.Items[0].Enabled:=Not CurrentPtr^.ReverseFont;
        ColorPopupMenu.Items[3].Enabled:=CurrentPtr^.ReverseFont;
      End;
    End;

    ColorPopupMenu.Popup(X+l.Left+Form1.Left+ConfigPanel.Left+ColorPanel.Left,
                         Y+l.Top+Form1.Top+ConfigPanel.Top+ColorPanel.Top+32);
  End;
end;


Procedure Load(Name : String);
Var B        : TBitmap;
    x        : Integer;
    y        : Integer;

    ScanLine : ScanLinePtrType;

    c, c2    : Integer;

    F        : File;
    t        : TListItem;
    u        : Integer;
    P        : ConvPtrType;
    IsGIF    : Boolean;
    GIF      : TGIFImage;

Begin
  OSTop:=-1;             // Remove selection
  ErrorShow:=False;      // Remove error box
  CurrentConvItem:=NIL;
  CurrentPtr:=NIL;
  Form1.ConvListView.Items.Clear;
  CurrentConvItem:=NIL;
  CurrentPtr:=NIL;

  AssignFile(F, Name);
  Reset(F, 1);
  BlockRead(F, c, 4);
  CloseFile(F);
  IsGIF:=(c=$38464947);     // "GIF8"

  PicPath:=Name;
  If Pos('\', PicPath)=0 Then PicPath:='.\';
  While PicPath[Length(PicPath)]<>'\' Do Delete(PicPath, Length(PicPath), 1);
  ChDir(PicPath);
  PicName:=Name;
  PicNameNoExt:=PicName;
  If Pos('.', PicNameNoExt)>0 Then Begin
    While PicNameNoExt[Length(PicNameNoExt)]<>'.' Do Delete(PicNameNoExt, Length(PicNameNoExt), 1);
    Delete(PicNameNoExt, Length(PicNameNoExt), 1);
  End;

  AssignFile(F, PicNameNoExt+'.PC4');
  {$i-}
  Reset(F, 1);
  {$i+}
  If IOResult=0 Then Begin
    BlockRead(F, Config, SizeOf(Config));
    PaletteNo:=0;                              // Use palette from config
    For u:=0 To 15 Do Begin
      Red[u]:=Config.Red[u];
      Green[u]:=Config.Green[u];
      Blue[u]:=Config.Blue[u];
    End;
    If Config.Tolerance=0 Then Config.Tolerance:=60; // Default value
    Form1.TrackBar1.Position:=Config.Tolerance;
    Repeat
      New(P);
      BlockRead(F, P^, SizeOf(P^), u);
      If u>0 Then Begin
        t:=Form1.ConvListView.Items.Add;
        t.SubItems.Add('');
        t.SubItems.Add('');
        t.SubItems.Add('');
        t.SubItems.Add('');
        t.Data:=P;
        UpdateConvItem(t);
      End;
      Until u=0;
    CloseFile(F);
  End;

  Form1.Caption:=AppTitle+' - '+PicName;

  B:=TBitmap.Create;

  If IsGIF Then Begin
    GIF:=TGIFImage.Create;
    GIF.LoadFromFile(PicName);
    B.Assign(GIF);
    GIF.Destroy;
  End Else B.LoadFromFile(PicName);

  B.PixelFormat:=pf15bit;

  PicWidth:=B.Width;
  PicHeight:=B.Height;

  OSWidth:=PicWidth;
  OSHeight:=PicHeight;

  For y:=0 To PicHeight-1 Do Begin
    scanline:=B.ScanLine[y];
    For x:=0 To PicWidth-1 Do Begin
      c:=ScanLine^[x] And $7fff;
      Pic[x, y]:=c;
      c2:=8*(((c And 31)) + ((c Div 32) And 31)*256 + ((c Div (32*32)) And 31)*256*256);
      Pic2[x, y]:=c2;
    End;
  End;

  B.Destroy;

  AssignPalette;

  Form1.StatusLabel.Caption:='Picture width '+IntToStr(PicWidth)+#13+
                           'Picture height '+IntToStr(PicHeight);

  Dec(LastZoom);
  UpdateOS;
  Inc(LastZoom);
  UpdateOS;
  Form3.Visible:=True;
  FixupMenu;
End;


procedure TForm1.Load1Click(Sender: TObject);


begin
  If OpenPicDialog.Execute Then Load(OpenPicDialog.FileName);
end;

Procedure SetBevel;
Var top              : Integer;
    r, x, y          : Integer;
    x1, x2, y1, y2   : Integer;
    c                : Integer;

Begin
  If CurrentPTR<>NIL Then Begin
    top:=CurrentPTR^.YStart;
    OSLeft:=CurrentPTR^.XStart;
    OSRight:=CurrentPTR^.Width*TypeWidth[CurrentPTR^.ConvType]+OSLeft;
    OSBottom:=CurrentPTR^.Height*TypeHeight[CurrentPTR^.ConvType]+top;
    OSTop:=top;  // must be last otherwise timer that updated selection may fuck up...

    For r:=0 To 15 Do ColLabels[r].Visible:=False;

    x1:=CurrentPtr^.XStart;
    y1:=CurrentPtr^.YStart;
    x2:=x1-1+CurrentPtr^.Width*TypeWidth[CurrentPtr^.ConvType];
    y2:=y1-1+CurrentPtr^.Height*TypeHeight[CurrentPtr^.ConvType];

    If x1<0 Then x1:=0;
    if y1<0 Then y1:=0;
    if x2>=PicWidth Then x2:=PicWidth-1;
    If y2>=PicHeight Then y2:=PicHeight-1;

    For x:=x1 To x2 Do For y:=y1 To y2 Do Begin
      c:=ColIndex[Pic[x, y]];
      If c<16 Then If Not ColLabels[c].Visible Then ColLabels[c].Visible:=True;
    End;
  End Else OSTop:=-1;
End;


Procedure SetEditSize;
Begin
  If CurrentPtr<>NIL Then Begin
    Form1.XSizeLabel.Caption:='* '+IntToStr(TypeWidth[CurrentPtr^.ConvType])+' = '+IntToStr(CurrentPtr^.Width*TypeWidth[CurrentPtr^.ConvType]);
    Form1.YSizeLabel.Caption:='* '+IntToStr(TypeHeight[CurrentPtr^.ConvType])+' = '+IntToStr(CurrentPtr^.Height*TypeHeight[CurrentPtr^.ConvType]);
  End;
End;


procedure TForm1.ConvListViewClick(Sender: TObject);
Var t : TListItem;
    P : ConvPtrType;
    r : Integer;
    m : TMenuItem;

begin
  t:=ConvListView.Selected;
  If t<>NIL Then Begin
    CurrentConvItem:=t;
    CurrentPtr:=t.Data;
    P:=CurrentPtr;
    Edit1.Text:=IntToStr(P^.XStart);
    Edit2.Text:=IntToStr(P^.YStart);
    Edit3.Text:=IntToStr(P^.Width);
    Edit4.Text:=IntToStr(P^.Height);
    HeaderLabel.Caption:=P^.Suffix+#13+Form2.TypeComboBox.Items[P^.ConvType];
    SetEditSize;

    For r:=0 To ColorPopupMenu.Items.Count-1 Do ColorPopupMenu.Items.Delete(0);

    For r:=1 To 15 Do If ColPosArr[P^.ConvType, r]<>'' Then Begin
      m:=TMenuItem.Create(ColorPopupMenu);
      m.Caption:=ColPosArr[P^.ConvType, r];
      If m.Caption='-' Then m.Caption:='&-';
      m.OnClick:=ColorSelectClick;
      m.Tag:=r;
      ColorPopupMenu.Items.Add(m);
    End;

    Case p^.FirstChar Of
      0 : N000000001.Checked:=True;
      1 : N010101011.Checked:=True;
      2 : N101010101.Checked:=True;
      3 : N111111111.Checked:=True;
      4 : Nodefaultfirstchar1.Checked:=True;
    End;

    SpritePrioCB.Enabled:=(TypeHeight[P^.ConvType]=21);
    SpritePrioCB.Checked:=P^.SpritePrio;
    OverlayLayerCB.Checked:=P^.Overlay;
    ReverseFontCB.Enabled:=(P^.ConvType In [1, 2]);
    ReverseFontCB.Checked:=p^.ReverseFont;

    For r:=0 To 15 Do ColLabels[r].Caption:=ColPosArr[CurrentPtr^.ConvType, CurrentPtr^.ColTypes[r]];
  End Else Begin
    CurrentConvItem:=NIL;
    CurrentPTR:=NIL;
  End;
  SetBevel;
  FixupMenu;
end;

procedure TForm1.Addconversion1Click(Sender: TObject);
begin
  Form2.ShowModal;
  FixupMenu;
end;

procedure TForm1.Save1Click(Sender: TObject);
Var F        : File;
    r        : Integer;
    P        : ConvPtrType;

begin
  For r:=0 To 15 Do Begin
    Config.Red[r]:=Red[r];
    Config.Green[r]:=Green[r];
    Config.Blue[r]:=Blue[r];
  End;

  AssignFile(F, PicNameNoExt+'.PC4');
  Rewrite(F, 1);
  BlockWrite(F, Config, SizeOf(Config));
  For r:=0 To Form1.ConvListView.Items.Count-1 Do Begin
    P:=Form1.ConvListView.Items[r].Data;
    BlockWrite(F, P^, SizeOf(P^));
  End;
  CloseFile(F);
end;

procedure TForm1.Edit1Enter(Sender: TObject);
Var i, u : Integer;
    l    : String;
    E    : TEdit;
    t    : TListItem;
    P    : ConvPtrType;

begin
  If Sender Is TEdit Then Begin
    E:=Sender As TEdit;
    l:=E.Text;
    Val(l, i, u);
    If u<>0 Then i:=0;
    t:=CurrentConvItem;
    P:=CurrentPtr;
    If p<>NIL Then Begin
      // If i<0 Then i:=0;
      If E.Tag>1 Then If i<1 Then i:=1;      // size must always be 1 or more
      If E.Tag=0 Then P^.XStart:=i;
      If E.Tag=1 Then P^.YStart:=i;
      If E.Tag=2 Then P^.Width:=i;
      If E.Tag=3 Then P^.Height:=i;

      E.Text:=IntToStr(i);

      SetBevel;
      SetEditSize;

      UpdateConvItem(t);
    End;
  End;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  If Key=#13 Then Edit1Enter(Sender);
end;

procedure TForm1.ConvListViewChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  If ConvListView.SelCount>0 Then ConvListViewClick(NIL);
end;

procedure TForm1.OverlayLayerCBClick(Sender: TObject);
begin
  If CurrentPtr<>NIL Then CurrentPtr^.Overlay:=OverlayLayerCB.Checked;
end;

procedure TForm1.SpritePrioCBClick(Sender: TObject);
begin
  If CurrentPtr<>NIL Then CurrentPtr^.SpritePrio:=SpritePrioCB.Checked;
end;

Function ByteText(a : Integer) : String;
Begin
  ByteText:=IntToStr(a)+' / $'+IntToHex(a, 4)+' bytes.';
End;

Procedure Convert(Var p : ConvPtrType);
Var IncFile                : TextFile;
    Suffix                 : String;
    ShortSuffix            : String;
    Main, FontFile         : File;
    b                      : Byte;
    w                      : Word;
    c                      : Integer;

    ColUse                 : Array[0..15] Of Boolean;
    Buf                    : Array[0..63] Of Byte;
    Map                    : Array[0..47, 0..20] Of Integer;

    XU, YU, XW, YH         : Integer;
    x1, y1, x, y           : Integer;

    Color                  : Integer;
    Colors                 : Array[0..MaxPicSize Div 8, 0..MaxPicSize Div 8] Of Byte;
    Attribs                : Array[0..MaxPicSize Div 8, 0..MaxPicSize Div 8] Of Byte;
    WC                     : Array[0..3] Of Integer;

    Font                   : Array[0..255] Of Int64;
    FontPos                : Integer;
    Ch                     : Int64;
    bm                     : Int64;

    ad                     : Integer;
    r                      : Integer;
    OK                     : Boolean;
    BackCol                : Integer;
    FontError              : Boolean;

    l                      : String;

    CharsAdded             : Integer;

Const con = '.const ';

  Procedure Error(n : String; Coords : Boolean);
  Var l : String;

  Begin
    Form4.visible:=True;
    If Coords Then l:='E'+IntToStr(x1)+','+IntToStr(y1)+' - '+IntToStr(x1+TypeWidth[p^.ConvType]-1)+','+
                   IntToStr(y1+TypeHeight[p^.ConvType]-1)+'  :  '+n Else l:='E'+n;
    AddStatusLine(l);
  End;


  Procedure CheckBackCol(c : Integer);
  Begin
    If BackCol=-1 Then Begin
      BackCol:=c;
    End Else Begin
      If BackCol<>c Then Error('Too many background colors.', True);
    End;
  End;


Begin
  AddStatusLine('A');
  AddStatusLine('B'+p^.Suffix);
  AddStatusLine('C');
  l:='DType : '+Form2.TypeComboBox.Items[p^.ConvType]+'.';
  If p^.Overlay Then If p^.SpritePrio Then l:=l+' Underlay layer.' Else l:=l+' Overlay layer.';
  AddStatusLine(l);
  XW:=TypeWidth[p^.ConvType];
  YH:=TypeHeight[p^.ConvType];

  BackCol:=-1;
  ch:=0; // just to remove compiler warning :(

  Suffix:=PicNameNoExt+'_'+p^.Suffix;
  ShortSuffix:=Suffix;
  While Pos('\', ShortSuffix)>0 Do Delete(ShortSuffix, 1, Pos('\', ShortSuffix));
  While Pos(' ', ShortSuffix)>0 Do ShortSuffix[Pos(' ', ShortSuffix)]:='_';

  AssignFile(IncFile, Suffix+'.inc');
  Rewrite(IncFile);

  AssignFile(Main, Suffix+'.prg');
  Rewrite(Main, 1);
  w:=$2000;
  BlockWrite(Main, w, 2);

  FillChar(Colors, SizeOf(Colors), #0);
  FillChar(Attribs, SizeOf(Attribs), #0);

  CharsAdded:=0;

  // main include file

  WriteLn(IncFile, con+ShortSuffix+'XStart=', p^.XStart);
  WriteLn(IncFile, con+ShortSuffix+'YStart=', p^.YStart);
  WriteLn(IncFile, con+ShortSuffix+'Width=', p^.Width);
  WriteLn(IncFile, con+ShortSuffix+'Height=', p^.Height);

  FillChar(Font, SizeOf(Font), #0);
  FontPos:=0;
  If p^.FirstChar<4 Then Begin
    FontPos:=1;
    Font[0]:=Int64(p^.FirstChar)*$5555555555555555;
    Inc(CharsAdded);
  End;
  FontError:=False;

  If p^.FontFile<>'' Then Begin // Load existing font
    Assign(FontFile, PicPath+p^.FontFile);
    {$i-}
    Reset(FontFile, 1);
    {$i+}
    If IOResult=0 Then Begin
      BlockRead(FontFile, w, 2);
      BlockRead(FontFile, Font[0], 2048, c);
      CloseFile(FontFile);
      FontPos:=c Div 8;
      AddStatusLine('DLoaded existing font "'+p^.FontFile+'"');
      AddStatusLine('DFont has '+IntToStr(FontPos)+' chars.');
      CharsAdded:=0;
    End Else Begin
      FontError:=True;
      Error('Could not open '+PicPath+p^.FontFile, False);
    End;
  End;

  // Conversion loop
  For YU:=0 To P^.Height-1 Do For XU:=0 To P^.Width-1 Do Begin
    FillChar(Buf, SizeOf(Buf), #0);
    FillChar(ColUse, SizeOf(ColUse), #0);
    FillChar(Map, SizeOf(Map), #255);
    For c:=0 To 3 Do WC[c]:=-1; // Work colors

    x1:=P^.XStart+XU*XW;
    y1:=P^.YStart+YU*YH;

    // Create color map and ColUse, skip Overlay pixels
    For x:=0 To XW-1 Do For y:=0 To YH-1 Do Begin
      If (x1+x)>=0 Then If (y+y1)>=0 Then If (x1+x)<PicWidth Then If (y1+y)<PicHeight Then Begin
        c:=Pic[x1+x, y1+y];
        If Not Overlay[x1+x, y1+y] Then If ColIndex[c]<16 Then Begin
          c:=ColIndex[c];
          ColUse[c]:=True;
          Map[x, y]:=c;
        End;
      End;
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Single color chars
    If p^.ConvType=1 Then Begin
      Color:=-1;

      For c:=0 To 15 Do If ColUse[c] Then Begin
        If p^.ColTypes[c]=2 Then Begin // Char color
          If Color<>-1 Then Error('Too many char colors used.', True);
          Color:=c;
        End;

        If p^.ColTypes[c]=1 Then CheckBackCol(c);
      End;

      Ch:=0;      // Init char
      bm:=1;      // Init multiplier
      For y:=0 To 7 Do For x:=0 To 7 Do Begin
        b:=Map[x, y];
        If Overlay[x1+x, y+y1] Then b:=255;

        If b<16 Then If p^.ColTypes[b]=2 Then Begin
          Ch:=Ch Or Int64(128 SHR x)*bm;
          If p^.Overlay Then Overlay[x1+x, y1+y]:=True;
        End;

        If x=7 Then bm:=bm*256;    // next 8 bits
      End;

      If Color=-1 Then For c:=0 To 15 Do If p^.ColTypes[c]=2 Then If Color=-1 Then Color:=c;

      Colors[YU, XU]:=Color;
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Multi color chars
    If p^.ConvType=2 Then Begin
      Color:=-1;

      For c:=0 To 7 Do If ColUse[c] Then If p^.ColTypes[c]=4 Then Begin // Char color
        If Color<>-1 Then Error('Too many char colors used.', True);
        Color:=c;
      End;

      For c:=0 To 15 Do If ColUse[c] Then If p^.ColTypes[c]=1 Then CheckBackCol(c);

      Ch:=0;      // Init char
      bm:=1;      // Init multiplier
      For c:=0 To 15 Do If ColUse[c] Then Begin
        For y:=0 To 7 Do For x:=0 To 3 Do Begin
          b:=Map[x*2, y];
          If Overlay[x1+x*2, y+y1] Then Begin
            b:=255;
            If Not Overlay[x1+x*2, y+y1] Then b:=Map[x*2+1, y];
          End;

          If b<16 Then Begin
            b:=p^.ColTypes[b]-1;

            If b>0 Then Begin
              Ch:=Ch+Int64(b SHL (2*(3-x)))*bm;

              If p^.Overlay Then Begin
                Overlay[x1+(x*2),   y1+y]:=True;
                Overlay[x1+(x*2)+1, y1+y]:=True;
              End;
            End;
          End;
          If x=3 Then bm:=bm*256;    // next 8 bits
        End;
      End;

      If Color=-1 Then For c:=0 To 7 Do If p^.ColTypes[c]=4 Then If Color=-1 Then Color:=c;

      Colors[YU, XU]:=Color Or 8;
    End;


    // Char mapping

    If p^.ReverseFont Then Ch:=Ch XOR -1;

    If p^.ConvType In [1, 2] Then Begin
      r:=-1;
      For c:=0 To FontPos-1 Do Begin
        If Font[c]=Ch Then r:=c;
      End;

      If r=-1 Then Begin
        If FontPos<256 Then Begin
          r:=FontPos;
          Font[r]:=ch;
          Inc(FontPos);
          Inc(CharsAdded);
        End Else Begin
          Error('Too many chars needed.', True);
          FontError:=True;
        End;
      End;

      Attribs[YU, XU]:=r;
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Single color sprites
    If p^.ConvType=3 Then Begin
      Color:=-1;

      For c:=0 To 15 Do If ColUse[c] Then If p^.ColTypes[c]=2 Then Begin // foreground
        If Color<>-1 Then Error('Too many colors for single color sprite', True);
        Color:=c;
        For x:=0 To 23 Do For y:=0 To 20 Do If Map[x, y]=c Then Begin
          ad:=(x Div 8)+(3*y);
          Buf[ad]:=Buf[ad] Or (128 SHR (x And 7));

          If p^.Overlay Then Overlay[x1+x, y1+y]:=True;
        End;
      End;

      If Color=-1 Then For c:=0 To 15 Do If p^.ColTypes[c]=2 Then If Color=-1 Then Color:=c;

      Colors[YU, XU]:=Color;
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Multi color sprites
    If p^.ConvType=4 Then Begin
      Color:=-1;

      For x:=0 To 11 Do For y:=0 To 20 Do Begin
        b:=Map[x*2, y];
        If Overlay[x1+x*2, y1+y] Then b:=Map[x*2+1, y];
        If b<16 Then Begin // Not overlay
          If p^.ColTypes[b]=3 Then Begin // Sprite color
            If (Color<>-1) And (Color<>b) Then Error('Too many colors for single color sprite', True);
            Color:=b;
          End;
          b:=p^.ColTypes[b]-1;
          If b>0 Then If b<4 Then Begin
            ad:=(x Div 4)+(3*y);
            b:=b*64;
            Buf[ad]:=Buf[ad] Or (b SHR ((x*2) And 7));
            If p^.Overlay Then Begin
              Overlay[x1+(x*2),   y1+y]:=True;
              Overlay[x1+(x*2)+1, y1+y]:=True;
            End;
          End;
        End;
      End;

      If Color=-1 Then For c:=0 To 15 Do If p^.ColTypes[c]=3 Then If Color=-1 Then Color:=c;

      Colors[YU, XU]:=Color;
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Hires bitmap
    If p^.ConvType=5 Then Begin
      For c:=0 To 15 Do Begin
        If p^.ColTypes[c]=4 Then Begin   // Fixed background
          If WC[1]=-1 Then WC[1]:=c Else Error('Cannot reassign fixed background color', False);
        End;

        If p^.ColTypes[c]=5 Then Begin   // Fixed foreground
          If WC[2]=-1 Then WC[2]:=c Else Error('Cannot reassign fixed foreground color', False);
        End;
      End;

      For c:=0 To 15 Do If ColUse[c] Then Begin
        b:=p^.ColTypes[c];
        If b>1 Then If b<4 Then Begin // Preferred color
          If WC[b-1]=-1 Then WC[b-1]:=c;
        End;
      End;

      For c:=0 To 15 Do If ColUse[c] Then Begin
        b:=0;
        For r:=1 To 2 Do If WC[r]=c Then b:=r;
        If b=0 Then For r:=2 DownTo 1 Do If WC[r]=-1 Then b:=r;
        If b>0 Then WC[b]:=c Else Error('Too many colors', True);
      End;

      For x:=0 To 7 Do For y:=0 To 7 Do Begin
        b:=Map[x, y];
        If Overlay[x1+x, y1+y] Then b:=255;
        If b<16 Then Begin
          r:=0;
          For c:=1 To 2 Do If WC[c]=b Then r:=c; // Found matching bitmap for work color

          If r=2 Then Begin
            Buf[y]:=Buf[y] Or (128 SHR x);
            If p^.Overlay Then Overlay[x1+x, y1+y]:=True;
          End;
        End;
      End;

      For c:=1 To 2 Do If WC[c]=-1 Then WC[c]:=0;
      Attribs[YU, XU]:=WC[1]+16*WC[2];
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Multi color bitmap
    If p^.ConvType=6 Then Begin
      For c:=0 To 15 Do Begin
        If p^.ColTypes[c]=2 Then CheckBackCol(c);

        If p^.ColTypes[c]=6 Then Begin   // Fixed 01 (Attr. upper)
          If WC[1]=-1 Then WC[1]:=c Else Error('Cannot reassign fixed color %01', True);
        End;

        If p^.ColTypes[c]=7 Then Begin   // Fixed 10 (Attr. lower)
          If WC[2]=-1 Then WC[2]:=c Else Error('Cannot reassign fixed color %10', True);
        End;

        If p^.ColTypes[c]=8 Then Begin   // Fixed 11 (D800)
          If WC[3]=-1 Then WC[3]:=c Else Error('Cannot reassign fixed color %11', True);
        End;
      End;

      For c:=0 To 15 Do If ColUse[c] Then Begin
        b:=p^.ColTypes[c];
        If b>2 Then If b<6 Then Begin // Preferred color
          If WC[b-2]=-1 Then WC[b-2]:=c;
        End;
      End;

      For c:=0 To 15 Do If ColUse[c] Then Begin
        If p^.ColTypes[c]<>2 Then Begin // Not background
          b:=0;
          For r:=1 To 3 Do If WC[r]=c Then b:=r;
          If b=0 Then For r:=3 DownTo 1 Do If WC[r]=-1 Then b:=r;
          If b>0 Then WC[b]:=c Else Error('Too many colors', True);
        End;
      End;

      For x:=0 To 3 Do For y:=0 To 7 Do Begin
        b:=Map[x*2, y];
        If Overlay[x1+x*2, y1+y] Then Begin
          b:=255;
          If Not Overlay[x1+1+x*2, y1+y] Then b:=Map[x*2+1, y];
        End;
        If b<16 Then Begin
          r:=0;
          For c:=1 To 3 Do If WC[c]=b Then r:=c; // Found matching bitmap for work color

          Buf[y]:=Buf[y] Or (64*r) SHR (x*2);
          If r>0 Then If p^.Overlay Then Begin
            Overlay[x1+(x*2),   y1+y]:=True;
            Overlay[x1+(x*2)+1, y1+y]:=True;
          End;
        End;
      End;

      For c:=0 To 3 Do If WC[c]=-1 Then WC[c]:=0;
      Colors[YU, XU]:=WC[3];
      Attribs[YU, XU]:=WC[1]*16+WC[2];
    End;

    ////////////////////////////////////////////////////////////////////////////

    // Double width single color sprites
    If p^.ConvType=7 Then Begin
      Color:=-1;

      For c:=0 To 15 Do If ColUse[c] Then If p^.ColTypes[c]>1 Then Begin // foreground
        If Color<>-1 Then Error('Too many colors for single color sprite', True);
        Color:=c;
        For x:=0 To 23 Do For y:=0 To 20 Do Begin
          b:=0;

          If Map[x*2, y]=c Then b:=1;
          If Map[x*2+1, y]=c Then b:=b+2;

          If p^.ColTypes[c]=2 Then If b<>1 Then b:=0; // even
          If p^.ColTypes[c]=3 Then If b<>2 Then b:=0; // Odd
          // 4 is even or odd, this is already implied :)
          If p^.ColTypes[c]=5 Then If b<>3 Then b:=0; // even and odd

          If b>0 Then Begin
            ad:=(x Div 8)+(3*y);
            Buf[ad]:=Buf[ad] Or (128 SHR (x And 7));

            If p^.Overlay Then Begin
              If (b And 1)>0 Then Overlay[x1+(x*2),   y1+y]:=True;
              If (b And 2)>0 Then Overlay[x1+(x*2)+1, y1+y]:=True;
            End;
          End;
        End;
      End;

      If Color=-1 Then For c:=0 To 15 Do If p^.ColTypes[c]>1 Then If Color=-1 Then Color:=c;

      Colors[YU, XU]:=Color;
    End;

    ////////////////////////////////////////////////////////////////////////////


    // Write main data except for font based conversions
    If p^.ConvType In [3, 4, 5, 6, 7] Then Begin
      b:=8;
      If TypeHeight[p^.ConvType]=21 Then b:=64;
      BlockWrite(Main, Buf[0], b);
    End;
  End;

  If p^.ConvType In [1, 2] Then Begin // Write font
    BlockWrite(Main, Font[0], 8*FontPos);
    AddStatusLine('DChars added to font : '+IntToStr(CharsAdded));
    If CharsAdded<>FontPos Then AddStatusLine('DChars in font : '+IntToStr(FontPos));
    AddStatusLine('DFont data : '+ByteText(8*FontPos));
  End Else AddStatusLine('DGraphic data : '+ByteText(FilePos(Main)-2));
  CloseFile(Main);
  If p^.FontFile<>'' Then Begin // Write existing font
    Erase(Main);
    Rewrite(FontFile, 1);
    w:=$2000;
    BlockWrite(FontFile, w, 2);
    BlockWrite(FontFile, Font[0], 8*FontPos);
    CloseFile(FontFile);
  End;

  If p^.ConvType In [1, 2] Then Begin // Write screen chars
    AssignFile(Main, ShortSuffix+'_Screen.prg');
    Rewrite(Main, 1);
    w:=$0c00;
    BlockWrite(Main, w, 2);
    For y:=0 To p^.Height-1 Do BlockWrite(Main, Attribs[Y, 0], p^.Width);
    CloseFile(Main);
    AddStatusLine('DScreen data : '+ByteText(p^.Height*p^.Width));
  End;

  If p^.ConvType In [5, 6] Then Begin // Write attributes
    AssignFile(Main, ShortSuffix+'_Attr.prg');
    Rewrite(Main, 1);
    w:=$0c00;
    BlockWrite(Main, w, 2);
    For y:=0 To p^.Height-1 Do BlockWrite(Main, Attribs[Y, 0], p^.Width);
    CloseFile(Main);

    b:=Attribs[0,0];
    OK:=True;
    For x:=0 To p^.Width-1 Do For y:=0 To p^.Height-1 Do If Attribs[y, x]<>b Then OK:=False;
    If OK Then Begin
      Erase(Main);
      WriteLn(IncFile, con+ShortSuffix+'FixedAttribs=', b);
      AddStatusLine('DFixed attribute value '+IntToStr(b)+' added to include file.');
    End Else AddStatusLine('DAttribute data : '+ByteText(p^.Height*p^.Width));
  End;

  If p^.ConvType In [1, 2, 3, 4, 6, 7] Then Begin // Write colors
    AssignFile(Main, ShortSuffix+'_Colors.prg');
    Rewrite(Main, 1);
    w:=$1000;
    BlockWrite(Main, w, 2);
    For y:=0 To p^.Height-1 Do BlockWrite(Main, Colors[Y, 0], p^.Width);
    CloseFile(Main);

    b:=Colors[0,0];
    OK:=True;
    For x:=0 To p^.Width-1 Do For y:=0 To p^.Height-1 Do If Colors[y, x]<>b Then OK:=False;
    If OK Then Begin
      Erase(Main);
      If p^.ConvType In [3, 4, 7] Then WriteLn(IncFile, con+ShortSuffix+'Color=', b);
      If p^.ConvType In [1, 2, 6] Then WriteLn(IncFile, con+ShortSuffix+'FixedD800=', b);
      AddStatusLine('DFixed color '+IntToStr(b)+' added to include file.');
    End Else AddStatusLine('DColor data : '+ByteText(p^.Height*p^.Width));
  End;

  If p^.ConvType In [2, 4] Then Begin // Sprite + char multicolors
    Color:=-1;
    For c:=0 TO 15 Do If p^.ColTypes[c]=2 Then Begin
      If Color=-1 Then Color:=c Else Error('Too many multicolor 1.', False);
    End;
    WriteLn(IncFile, con+ShortSuffix+'MC1=', Color);

    Color:=-1;
    r:=4;
    If p^.ConvType=2 Then r:=3;
    For c:=0 TO 15 Do If p^.ColTypes[c]=r Then Begin
      If Color=-1 Then Color:=c Else Error('Too many multicolor 2.', False);
    End;
    WriteLn(IncFile, con+ShortSuffix+'MC2=', Color);
  End;

  // Background color
  If p^.ConvType In [1, 2, 6] Then Begin
    WriteLn(IncFile, con+ShortSuffix+'Background=', BackCol);
    AddStatusLine('DBackground color '+IntToStr(BackCol)+' added to include file.');
  End;
  CloseFile(IncFile);
End;


procedure TForm1.Convertall1Click(Sender: TObject);
Var r : Integer;
    P : ConvPtrType;

begin
  If Not Converting Then Begin
    Converting:=True;
    FillChar(Overlay, SizeOf(Overlay), #0);
    ClearStatus;
    AddStatusLine('F');
    AddStatusLine('FStarting conversion...');

    // First handle overlay
    For r:=0 To ConvListView.Items.Count-1 Do Begin
      p:=ConvListView.Items[r].Data;
      If p.Overlay Then Convert(p);
    End;

    // Then handle the rest
    For r:=0 To ConvListView.Items.Count-1 Do Begin
      p:=ConvListView.Items[r].Data;
      If Not p.Overlay Then Convert(p);
    End;

    If Not StatusError Then Begin
      Form4.Color:=$80ff80;
      AddStatusLine('F');
      AddStatusLine('FConversion completed without errors.');
    End;
    Converting:=False;
  End;
end;


Procedure LoadFile(l : String);
Var n : String;

Begin
  If l[Length(l)]='4' Then Begin // .pc4 file
    Delete(l, Length(l)-2, 3);
    If FileExists(l+'gif') Then l:=l+'gif' Else l:=l+'bmp';
  End;
  If FileExists(l) Then Begin
    n:=AnsiUpperCase(l);
    While Pos('.', n)>0 Do Delete(n, 1, Pos('.', n));
    If n='GIF' Then Load(l);
    If n='BMP' Then Load(l);
  End;
End;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;

  ClearStatus;

  If ParamStr(1)<>'' Then LoadFile(ParamStr(1));

  If ParamStr(2)<>'' Then Begin
    Convertall1.Click;
    If Not StatusError Then Application.Terminate;
  End;

  Form1.TrackBar1.OnChange:=TrackBar1Change;
  Form1.ConvListView.SetFocus;
end;

procedure TForm1.ReverseFontCBClick(Sender: TObject);
begin
  If CurrentPtr<>NIL Then CurrentPtr^.ReverseFont:=ReverseFontCB.Checked;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.ConvListViewContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
Var r : Integer;

begin
  If ConvListView.Selected=NIL Then Handled:=True Else Begin
    Resetcolorassignments1.Enabled:=False;
    For r:=0 To 15 Do If CurrentPtr^.ColTypes[r]>1 Then Resetcolorassignments1.Enabled:=True;
    Assignalternatefontfile1.Enabled:=(CurrentPtr^.ConvType In [1, 2]);
    FirstChar.Enabled:=Assignalternatefontfile1.Enabled And (CurrentPtr^.FontFile='');
    Clearalternatefontfine1.Enabled:=(CurrentPtr^.FontFile<>'');
  End;
end;

procedure TForm1.Resetcolorassignments1Click(Sender: TObject);
Var r : Integer;

begin
  If CurrentPtr<>NIL THen If Application.MessageBox('Reset color assignments?', 'Please confirm', MB_ICONQUESTION Or MB_YESNO)=IDYes Then Begin
    For r:=0 TO 15 Do CurrentPtr^.ColTypes[r]:=1;
    UpdateConvItem(CurrentConvItem);
    ConvListView.OnClick(NIL);
  End;
end;

procedure TForm1.Assignalternatefontfile1Click(Sender: TObject);
Var F      : File Of Byte;
    s      : Integer;

begin
  If CurrentPtr<>NIL Then If OpenFontDialog.Execute Then Begin
    s:=7; // Wrong size :)
    AssignFile(F, OpenFontDialog.FileName);
    {$i-}
    Reset(F);
    {$i+}
    If IOResult=0 Then Begin
      s:=FileSize(F);
      CloseFile(F);
    End;

    If (((s-2) And 7)<>0) Or (s>$0801) Then Begin
      Application.MessageBox('File size suggests this is not a font file.', 'Wrong file size', MB_ICONERROR);
    End Else Begin
      CurrentPtr^.FontFile:=ExtractRelativePath(PicPath, OpenFontDialog.FileName);
      UpdateConvItem(CurrentConvItem);
    End;
  End;
end;

procedure TForm1.Clearalternatefontfine1Click(Sender: TObject);
begin
  CurrentPtr^.FontFile:='';
  UpdateConvItem(CurrentConvItem);
end;

procedure TForm1.Nodefaultfirstchar1Click(Sender: TObject);
Var m : TMenuItem;

begin
  If Sender Is TMenuItem Then Begin
    m:=Sender As TMenuItem;
    If CurrentPtr<>NIL Then CurrentPtr^.FirstChar:=m.Tag;
  End;
end;

procedure TForm1.RegisterPC4filetypeinregistry1Click(Sender: TObject);
Var R : TRegistry;

begin
  R:=TRegistry.Create;
  R.RootKey:=HKEY_CURRENT_USER;
  If R.OpenKey('Software\Classes\PictureConverter4', True) Then Begin
    R.WriteString('', 'Picture Converter 4 file');
    R.OpenKey('shell', True);
    R.OpenKey('Convert!', True);
    R.OpenKey('command', True);
    R.WriteString('', '"'+ParamStr(0)+'" "%1" Convert');
    R.CloseKey;
  End;

  If R.OpenKey('Software\Classes\PictureConverter4', True) Then Begin
    R.OpenKey('shell', True);
    R.OpenKey('open', True);
    R.OpenKey('command', True);
    R.WriteString('', '"'+ParamStr(0)+'" "%1"');
    R.CloseKey;
  End;

  If R.OpenKey('Software\Classes\.PC4', True) Then Begin
    R.WriteString('', 'PictureConverter4');
    R.CloseKey;
  End;

  R.Destroy;
end;

procedure TForm1.UnregisterPC4filetype1Click(Sender: TObject);
Var R : TRegistry;

begin
  R:=TRegistry.Create;
  R.RootKey:=HKEY_CURRENT_USER;
  If R.KeyExists('Software\Classes\PictureConverter4') Then R.DeleteKey('Software\Classes\PictureConverter4');
  If R.KeyExists('Software\Classes\.PC4') Then R.DeleteKey('Software\Classes\.PC4');
end;

procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
Var DropH                 : HDROP;      // drop handle
    FileNameLength        : Integer;    // length of a dropped file name
    FileName              : string;     // a dropped file name

Begin
  inherited;
  DropH:=Msg.Drop;    // Store drop handle from the message
  try
    FileNameLength:=DragQueryFile(DropH, 0, nil, 0);
    SetLength(FileName, FileNameLength);
    DragQueryFile(DropH, 0, PChar(FileName), FileNameLength + 1);
    LoadFile(FileName);
  finally
    DragFinish(DropH);
  end;
  Msg.Result:=0;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Config.Tolerance:=TrackBar1.Position;
  AssignPalette;
end;

procedure TForm1.Defaultpalette11Click(Sender: TObject);
begin
  PaletteNo:=1;
  AssignPalette;
end;

procedure TForm1.Defaultpalette21Click(Sender: TObject);
begin
  PaletteNo:=2;
  AssignPalette;
end;

procedure TForm1.Resetcolortolerance1Click(Sender: TObject);
begin
  TrackBar1.Position:=60;
  AssignPalette;
end;

procedure TForm1.Deleteconversion1Click(Sender: TObject);
Var l : String;

begin
  l:='Do you want to delete '+CurrentPtr^.Suffix+' ?';
  If Application.MessageBox(PChar(l), 'Confirm delete', MB_ICONQUESTION Or MB_YESNOCANCEL)=IDYes Then Begin
    OSTop:=-1;             // Remove selection
    CurrentConvItem:=NIL;
    CurrentPtr:=NIL;
    ConvListView.ItemFocused.Delete;
  End;
  FixupMenu;
end;

procedure TForm1.ColorSelectClick(Sender: TObject);
Var m : TMenuItem;
    l : Integer;

begin
  If Sender Is TMenuItem Then If CurrentPtr<>NIL Then Begin
    m:=Sender As TMenuItem;
    l:=ColorPopupMenu.Tag;
    CurrentPtr^.ColTypes[l]:=m.Tag;
    ColLabels[l].Caption:=ColPosArr[CurrentPtr^.ConvType, CurrentPtr^.ColTypes[l]];
  End;
end;

end.


