unit PCUnit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PCUnit1, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm2 = class(TForm)
    AddPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TypeComboBox: TComboBox;
    SuffixEdit: TEdit;
    AddButton: TButton;
    Cancelbutton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SuffixEditChange(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
    procedure SuffixEditKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.FormCreate(Sender: TObject);
begin
  Font:=Form1.Font;
  Caption:=Form1.Caption;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  SuffixEdit.Text:='';
  TypeComboBox.ItemIndex:=0;
  AddButton.Enabled:=False;
  SuffixEdit.SetFocus;
end;

procedure TForm2.SuffixEditChange(Sender: TObject);
Var OK : Boolean;
    l  : String;
    r  : Integer;

begin
  OK:=(Trim(SuffixEdit.Text)<>'') And (TypeComboBox.ItemIndex>0);

  If OK Then Begin // Check suffix name
    l:=AnsiUpperCase(Trim(SuffixEdit.Text));
    For r:=0 To Form1.ConvListView.Items.Count-1 Do If AnsiUpperCase(Trim(Form1.ConvListView.Items[r].Caption))=l Then OK:=False;    
  End;

  AddButton.Enabled:=OK;
end;

procedure TForm2.AddButtonClick(Sender: TObject);
Var SName : String;
    FName : String;
    F     : File Of Byte;
    t     : TListItem;

    P     : ConvPtrType;

    r     : Integer;


begin
  SName:=Trim(SuffixEdit.Text);
  FName:=PicNameNoExt+SName+'_testfile_';
  AssignFile(F, FName);
  {$i-}
  Rewrite(F);
  {$i+}
  If IOResult=0 Then Begin
    CloseFile(F);
    Erase(F);

    t:=Form1.ConvListView.Items.Add;
    t.SubItems.Add('');
    t.SubItems.Add('');
    t.SubItems.Add('');
    t.SubItems.Add('');
    New(P);
    t.Data:=P;
    FillChar(P^, SizeOf(P^), #0);
    For r:=0 To 15 Do P^.ColTypes[r]:=1;
    P^.ConvType:=TypeComboBox.ItemIndex;
    P^.Suffix:=SName;

    P^.Width:=PicWidth Div TypeWidth[P^.ConvType];
    P^.Height:=PicHeight Div TypeHeight[P^.ConvType];

    UpdateConvItem(t);
    Form2.Close;
    t.Selected:=True;
  End Else Application.MessageBox('Invalid suffix, check for illegal chars.', 'Suffix name error', MB_IconError);
end;

procedure TForm2.SuffixEditKeyPress(Sender: TObject; var Key: Char);
begin
  If Key=#27 Then Cancelbutton.Click; 
end;

end.
