unit PCUnit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, Menus, StdCtrls;

type
  TImage = class(ExtCtrls.TImage);

  TForm3 = class(TForm)
    BevelTimer: TTimer;
    StatusBar: TStatusBar;
    Image: TImage;
    PopupMenu1: TPopupMenu;
    Outline1: TMenuItem;
    Zoom101: TMenuItem;
    Zoom21: TMenuItem;
    Zoom31: TMenuItem;
    Zoom41: TMenuItem;
    N1: TMenuItem;
    ColSelectPanel: TPanel;
    ColorCancelButton: TButton;
    N2: TMenuItem;
    Assigncolortopalette1: TMenuItem;
    Showselectedunitgrid1: TMenuItem;
    ColorDialog1: TColorDialog;
    Changegridcolor1: TMenuItem;
    N3: TMenuItem;
    Settopleftselection1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BevelTimerTimer(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ImageMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure Outline1Click(Sender: TObject);
    procedure Zoom101Click(Sender: TObject);
    procedure Zoom21Click(Sender: TObject);
    procedure Zoom31Click(Sender: TObject);
    procedure Zoom41Click(Sender: TObject);
    procedure Assigncolortopalette1Click(Sender: TObject);
    procedure ColorCancelButtonClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Showselectedunitgrid1Click(Sender: TObject);
    procedure Changegridcolor1Click(Sender: TObject);
    procedure ImageDblClick(Sender: TObject);
    procedure Settopleftselection1Click(Sender: TObject);
    procedure ImageContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

  ErrorShow                                  : Boolean;
  ERTop, ERLeft, ERRight, ERBottom           : Integer;
  OSTop, OSLeft, OSRight, OSBottom           : Integer;
  OSWidth, OSHeight                          : Integer;
  LastZoom                                   : Integer;


Procedure UpdateOS;


implementation

uses PCUnit1;

{$R *.dfm}

Type ScanLineType = Array[0..10000] Of Integer;

     ScanLinePtrType = ^ScanLineType;

Var Zoom                                      : Integer;
    ColorRead                                 : Integer;   // the color from onmousemove
    LastOSSum                                 : Integer;
    LastERSum                                 : Integer;

    SelCol                                    : Integer;
    ErrCol                                    : Integer;

    ColLabels                                 : Array[0..15] Of TLabel;
    GridColor                                 : TColor;

    XPos, YPos                                : Integer;
    SizeZoomAllowed                           : Boolean;

    
procedure TForm3.FormCreate(Sender: TObject);
Var y : Integer;

begin
  ErrorShow:=False;
  SizeZoomAllowed:=False;
  LastZoom:=1;
  OSTop:=-1;
  LastOSSum:=12345;
  LastERSum:=12345;
  GridColor:=$ffff40;
  
  Zoom:=30;
  Form3.Caption:=Form1.Caption+' - loaded image';
  Font:=Form1.Font;

  Image.OnMouseWheel:=ImageMouseWheel;
  Form3.OnMouseWheel:=FormMouseWheel;
  ColSelectPanel.Visible:=False;

  For y:=0 To 15 Do Begin
    ColLabels[y]:=TLabel.Create(Form3);
    ColLabels[y].Caption:='';
    ColLabels[y].OnClick:=Label1Click;
    ColLabels[y].AutoSize:=False;
    ColLabels[y].Alignment:=taCenter;
    ColLabels[y].Parent:=Form3.ColSelectPanel;
    ColLabels[y].Tag:=y;
  End;
end;

procedure TForm3.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=Application.Terminated;
  If Not CanClose Then Form1.BringToFront;
end;

procedure TForm3.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);

Var x1, y1 : Integer;
    x2, y2 : Integer;
    xs, ys : Integer;

    l      : ShortString;
    xw, yh : Integer;
    xu, yu : Integer;

    Cols   : Array[0..255] Of Boolean;

    r, c   : Integer;

begin
  x1:=X*10 Div Zoom;
  y1:=Y*10 Div Zoom;

  XPos:=x1;
  YPos:=y1;

  ColorRead:=(Pic2[X1, Y1] And $FF)*$10000+(Pic2[x1, y1] And $ff00)+(Pic2[x1, y1] And $ff0000) Div $10000;
  StatusBar.Panels[0].Text:=IntToStr(ColorRead);
  StatusBar.Panels[2].Text:=IntToSTr(x1)+','+IntToStr(y1);

  l:='No selection';
  If CurrentPtr<>NIL Then Begin
    xs:=CurrentPtr^.XStart;
    ys:=CurrentPtr^.YStart;
    x1:=x1-xs;
    y1:=y1-ys;
    xw:=TypeWidth[CurrentPtr^.ConvType];
    yh:=TypeHeight[CurrentPtr^.ConvType];
    If x1>=0 Then If y1>=0 Then If x1<CurrentPtr^.Width*xw Then If y1<CurrentPtr^.Height*yh Then Begin
      xu:=x1 Div xw;
      yu:=y1 Div yh;
      l:='('+IntToStr(xs)+','+IntToStr(ys)+' to '+
         IntToStr(xs-1+xw*CurrentPtr^.Width)+','+IntToStr(ys-1+yh*CurrentPtr^.Height)+
         ') Unit '+IntToStr(xu)+','+IntToStr(yu)+
         '   Rel. pos: ';

      If TypePixelW[CurrentPtr^.ConvType]=1 Then l:=l+IntToStr(x1-xu*xw)+','+IntToStr(y1-yu*yh) Else Begin
        l:=l+IntToStr((x1-xu*xw) Div 2)+','+IntToStr(y1-yu*yh);
        If (x1 And 1)=0 Then l:=l+' even' Else l:=l+' odd';
      End;

      FillChar(Cols, SizeOf(Cols), #0);
      For x2:=0 To xw-1 Do For y2:=0 To yh-1 Do Begin
        Cols[ColIndex[Pic[xs+xw*xu+x2, ys+yh*yu+y2]]]:=True;
      End;

      c:=0;
      For r:=0 To 15 Do If Cols[r] Then Inc(c);
      If Cols[254] Then Inc(c);
      l:=l+'  '+IntToStr(c)+' color';
      If c<>1 Then l:=l+'s';

      If Cols[254] Then l:=l+'  UNASSIGNED COLOR - CHECK PALETTE';


    End;
  End;
  Form3.StatusBar.Panels[3].Text:=l;
end;

procedure TForm3.BevelTimerTimer(Sender: TObject);
Var x1, y1, x2, y2, c         : Integer;
    OSSum, ERSum              : Integer;

begin
  OSSum:=(OSTop+2345*OSLeft+65432*OSRight+98765*OSBottom);
  ERSum:=(ERTop+2345*ERLeft+65432*ERRight+98765*ERBottom);
  If ErrorShow Then Inc(ERSum, 1234567890);

  If (LastOSSum<>OSSum) Or (LastERSum<>ERSum) Then Begin
    LastOSSum:=OSSum;
    LastERSum:=ERSum;
    UpdateOS;
  End;

  If Outline1.Checked Then Begin
    IF OSTop<>-1 Then Begin  // -1 = no selection
      Inc(SelCol);
      c:=(SelCol And 15);
      If c>7 THen c:=8-(SelCol And 7);
      c:=c*31;
      c:=c Or $ffff00;
      Form3.Image.Canvas.Pen.Color:=c;

      y1:=((OSTop*Zoom) Div 10)-1;
      x1:=((OSLeft*Zoom) Div 10)-1;

      y2:=(OSBottom*Zoom) Div 10;
      x2:=(OSRight*Zoom) Div 10;

      Form3.Image.Canvas.MoveTo(x1, y1);
      Form3.Image.Canvas.LineTo(x2, y1);
      Form3.Image.Canvas.LineTo(x2, y2);
      Form3.Image.Canvas.LineTo(x1, y2);
      Form3.Image.Canvas.LineTo(x1, y1);

      c:=c Div 2;
      Form3.Image.Canvas.Pen.Color:=c And $7f7f7f;
      Dec(x1);
      Dec(y1);
      Inc(x2);
      Inc(y2);

      Form3.Image.Canvas.MoveTo(x1, y1);
      Form3.Image.Canvas.LineTo(x2, y1);
      Form3.Image.Canvas.LineTo(x2, y2);
      Form3.Image.Canvas.LineTo(x1, y2);
      Form3.Image.Canvas.LineTo(x1, y1);
    End;
  End;

  If ErrorShow Then Begin
    Inc(ErrCol);
    c:=(ErrCol And 15);
    If c>7 THen c:=8-(ErrCol And 7);
    c:=c*31;
    Form3.Image.Canvas.Pen.Color:=c;

    y1:=((ERTop*Zoom) Div 10)-1;
    x1:=((ERLeft*Zoom) Div 10)-1;

    y2:=((ERBottom+1)*Zoom) Div 10;
    x2:=((ERRight+1)*Zoom) Div 10;

    Form3.Image.Canvas.MoveTo(x1, y1);
    Form3.Image.Canvas.LineTo(x2, y1);
    Form3.Image.Canvas.LineTo(x2, y2);
    Form3.Image.Canvas.LineTo(x1, y2);
    Form3.Image.Canvas.LineTo(x1, y1);
    Dec(x1);
    Dec(y1);
    Inc(x2);
    Inc(y2);
    Form3.Image.Canvas.MoveTo(x1, y1);
    Form3.Image.Canvas.LineTo(x2, y1);
    Form3.Image.Canvas.LineTo(x2, y2);
    Form3.Image.Canvas.LineTo(x1, y2);
    Form3.Image.Canvas.LineTo(x1, y1);
  End;
end;

procedure TForm3.ImageMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
Var lz : Integer;

Begin
  lz:=Zoom;
  if WheelDelta>=0 Then If Zoom<160 Then Inc(Zoom);
  if WheelDelta<0 Then If Zoom>10 Then Dec(Zoom);

  If ColSelectPanel.Visible Then Zoom:=lz;     // no zoom when selecting color
  
  If lz<>Zoom Then UpdateOS;
  
  Handled:=True;
End;

procedure TForm3.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
const
  {$J+}
  performing : boolean = false;
  {$J-}
var
  ctrl : TControl;
  wc : TWinControl;
begin
  Handled := false;

  if NOT performing then
  begin
    wc := FindVCLWindow(MousePos);
    if Assigned(wc) then
    begin
      ctrl := wc.ControlAtPos(wc.ScreenToClient((MousePos)), false, false);
      if Assigned(ctrl) then
      begin
        performing := true;
        try
          ctrl.Perform(CM_MOUSEWHEEL, WheelDelta, MakeLParam(MousePos.X, MousePos.Y));
        finally
          performing := false;
        end;
        Handled := true;
      end;
    end;
  end;
end;


Procedure UpdateOS;

Var Lines            : Array[0..19] Of ScanLinePtrType;
    l                : ShortString;

    x, y, x1, y1     : Integer;
    x2, y2           : Integer;
    r                : Integer;

    B                : TBitmap;
    c                : Integer;
    GridColor2       : Integer;


Begin
  SizeZoomAllowed:=False;
  Application.ProcessMessages;

  B:=TBitmap.Create;
  B.PixelFormat:=pf32bit;
  B.Height:=(OSHeight*Zoom) Div 10;
  B.Width:=(OSWidth*Zoom) Div 10;

  B.Canvas.Pixels[0,0]:=0;

  For y:=0 To OSHeight-1 Do Begin
    For r:=0 To 19 Do Lines[r]:=NIL;
    r:=0;
    y1:=(y*Zoom) Div 10;
    While (y1<(((y+1)*zoom) Div 10)) Do Begin
      Lines[r]:=B.ScanLine[y1];
      inc(y1);
      Inc(r);
    End;

    For x:=0 To OSWidth-1 Do Begin // Draw picture, including faded unselected area
      c:=Pic2[x, y];
      If OSTop<>-1 Then If Not Form3.OutLine1.Checked Then Begin // Fade unselected
        If (y<OSTop) Or (y>=OSBottom) Or (x<OSLeft) Or (x>=OSRight) Then Begin
          c:=(c Div 4) And $3f3f3f;
          c:=c+$3030b0;
        End;
      End;
      For r:=0 To 19 Do If Lines[r]<>NIL Then For x1:=((x*Zoom) Div 10) To (((x+1)*Zoom) Div 10)-1 Do Lines[r]^[x1]:=c;
    End;
  End;

  If Form3.Showselectedunitgrid1.Checked Then If CurrentPtr<>NIL Then Begin
    GridColor2:=GridColor And $ff00+((GridColor And $ff0000) Div $10000)+$10000*(GridColor And $ff);

    For y:=0 To CurrentPtr^.Height Do Begin
      y1:=(Zoom*(CurrentPtr^.YStart+TypeHeight[CurrentPtr^.ConvType]*y) Div 10)-1;
      If y=CurrentPtr^.Height Then Inc(y1);
      If y1>=0 Then If y1<B.Height Then Begin
        Lines[0]:=B.ScanLine[y1];
        x1:=Zoom*CurrentPtr^.XStart Div 10;
        x2:=Zoom*(CurrentPtr^.XStart+TypeWidth[CurrentPtr^.ConvType]*CurrentPtr^.Width) Div 10;
        If x1<0 Then x1:=0;
        If x2>=b.Width Then x2:=b.Width-1;
        For x:=x1 To x2 do Lines[0]^[x]:=GridColor2;
      End;
    End;

    For x:=0 To CurrentPtr^.Width Do Begin
      x1:=(Zoom*(CurrentPtr^.XStart+TypeWidth[CurrentPtr^.ConvType]*x) Div 10)-1;
      If x=CurrentPtr^.Width Then Inc(x1);
      If x1>=0 Then If x1<B.Width Then Begin
        y1:=(Zoom*CurrentPtr^.YStart Div 10)-1;
        y2:=Zoom*(CurrentPtr^.YStart+TypeHeight[CurrentPtr^.ConvType]*CurrentPtr^.Height) Div 10;

        If y1<0 Then y1:=0;
        If y2>=B.Height Then y2:=B.Height-1;
        For y:=y1 To y2 Do Begin
          Lines[0]:=B.ScanLine[y];
          Lines[0]^[x1]:=GridColor2;
        End;
      End;
    End;
  End;

  // Update screen according to last zoom position
  If Zoom>LastZoom Then Begin
    Form3.ClientWidth:=(OSWidth*Zoom) Div 10;
    Form3.ClientHeight:=(OSHeight*Zoom) Div 10+Form3.StatusBar.Height;
  End;
  Form3.Image.Picture.Bitmap.Assign(B);
  B.Destroy;
  If Zoom<LastZoom Then Begin
    Form3.ClientWidth:=(OSWidth*Zoom) Div 10;
    Form3.ClientHeight:=(OSHeight*Zoom) Div 10+Form3.StatusBar.Height;
  End;

  l:='Zoom '+IntToStr(Zoom);
  Insert(',', l, Length(l));
  Form3.StatusBar.Panels[1].Text:=l;

  Form3.OnCanResize:=Form3.FormCanResize;
  LastZoom:=Zoom;
  Application.ProcessMessages;
  SizeZoomAllowed:=True;
End;


procedure TForm3.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  If Panel.Style=psOwnerDraw Then Begin
    With StatusBar.Canvas Do Begin
      Brush.Color:=ColorRead;
      FillRect(Rect);
    End;
  End;
end;

procedure TForm3.Outline1Click(Sender: TObject);
begin
  Outline1.Checked:=Not OutLine1.Checked;
  UpdateOS;
end;

Procedure SetZoom(z : Integer);
Begin
  If Not Form3.ColSelectPanel.Visible Then Begin
    Zoom:=z;
    UpdateOS;
  End;
End;

procedure TForm3.Zoom101Click(Sender: TObject);
begin
  SetZoom(10);
end;

procedure TForm3.Zoom21Click(Sender: TObject);
begin
  SetZoom(20);
end;

procedure TForm3.Zoom31Click(Sender: TObject);
begin
  SetZoom(30);
end;

procedure TForm3.Zoom41Click(Sender: TObject);
begin
  SetZoom(40);
end;

procedure TForm3.Assigncolortopalette1Click(Sender: TObject);
Var x, y       : Integer;
    r          : Integer;
    xc, yc     : Integer;

begin
  ColSelectPanel.Left:=20;
  ColSelectPanel.Top:=20;
  ColSelectPanel.Height:=Image.Height-40;
  ColSelectPanel.Width:=Image.Width-40;
  ColSelectPanel.Color:=ColorRead;
  ColSelectPanel.Tag:=ColorRead;

  ColorCancelButton.Width:=ColSelectPanel.Width;
  ColorCancelButton.Left:=0;
  ColorCancelButton.Top:=ColSelectPanel.Height-ColorCancelButton.Height;

  x:=ColSelectPanel.ClientWidth-30;
  y:=ColSelectPanel.ClientHeight-30-ColorCancelButton.Height;
  xc:=(ColSelectPanel.ClientWidth-((3*(x Div 4)+(x Div 5)))) Div 2;
  yc:=(ColSelectPanel.ClientHeight-ColorCancelButton.Height-((3*(y Div 4)+(y Div 5)))) Div 2;

  For r:=0 To 15 Do Begin
    ColLabels[r].Width:=x Div 5;
    ColLabels[r].Height:=y Div 5;
    ColLabels[r].Top:=(y Div 4)*(r Div 4)+yc;
    ColLabels[r].Left:=(x Div 4)*(r And 3)+xc;

    ColLabels[r].Color:=Red1[r]+$100*Green1[r]+$10000*Blue1[r];
    ColLabels[r].Font.Color:=0;
    If Red1[r]+Green1[r]+Blue1[r]<500 Then ColLabels[r].Font.Color:=clWhite;
  End;

  ColSelectPanel.Visible:=True;
  ColSelectPanel.BringToFront;
  ColSelectPanel.SetFocus;
end;

procedure TForm3.ColorCancelButtonClick(Sender: TObject);
begin
  ColSelectPanel.Visible:=False;
end;

procedure TForm3.Label1Click(Sender: TObject);
Var y : Integer;
    l : TLabel;

begin
  If Sender Is TLabel Then Begin
    l:=Sender As TLabel;
    y:=l.Tag;
    Red[y]:=ColSelectPanel.Tag And $ff;
    Green[y]:=(ColSelectPanel.Tag Div $100) And $ff;
    Blue[y]:=(ColSelectPanel.Tag Div $10000) And $ff;

    PaletteNo:=0;
    AssignPalette;
    ColorCancelButton.Click;
  End;
end;

procedure TForm3.Showselectedunitgrid1Click(Sender: TObject);
begin
  Showselectedunitgrid1.Checked:=Not Showselectedunitgrid1.Checked;
  UpdateOS;
end;

procedure TForm3.Changegridcolor1Click(Sender: TObject);
begin
  If ColorDialog1.Execute Then Begin
    GridColor:=ColorDialog1.Color;
    UpdateOS;
  End;
end;

procedure TForm3.ImageDblClick(Sender: TObject);
begin
  Showselectedunitgrid1.Click;
end;

procedure TForm3.Settopleftselection1Click(Sender: TObject);
begin
  If CurrentPtr<>NIL Then Begin
    CurrentPtr^.XStart:=XPos;
    CurrentPtr^.YStart:=YPos;

    Form1.ConvListViewClick(NIL);
    UpdateConvItem(CurrentConvItem);
  End;
end;

procedure TForm3.ImageContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  Settopleftselection1.Enabled:=(CurrentPtr<>NIL);
end;

procedure TForm3.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);

Var LZ : Integer;

begin
  Resize:=True;

  If SizeZoomAllowed Then If OSHeight>0 Then Begin // Zoom by resizing
    lz:=Zoom;

    Zoom:=(NewHeight-Form3.Height+Form3.ClientHeight)*10 Div OSHeight;
    If Zoom<10 Then Zoom:=10;
    If Zoom>160 Then Zoom:=160;

    If Zoom<>lz Then UpdateOS;

    Resize:=False;
  End;
end;

end.
