unit PCUnit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm4 = class(TForm)
    StatusList: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure StatusListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure StatusListClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

  StatusError : Boolean;
  
Procedure ClearStatus;
Procedure AddStatusLine(l : String);

implementation

uses PCUnit1, PCUnit3;

{$R *.dfm}

Var First : Boolean;

procedure TForm4.FormCreate(Sender: TObject);
begin
  First:=True;
  Font:=Form1.Font;
  Caption:=Form1.Caption+' - Converter log';
  StatusList.ItemHeight:=Form4.Canvas.TextHeight('WALT')+2;
end;


Procedure AddStatusLine(l : String);
Begin
  Form4.StatusList.Items.Add(l);
  ErrorShow:=False;
  Application.ProcessMessages;
End;


Procedure ClearStatus;
Begin
  StatusError:=False;
  Form4.StatusList.Clear;
  If First Then Begin
    AddStatusLine('F');
    AddStatusLine('GWalt of Bonzai');
    AddStatusLine('F');
    AddStatusLine('FPresents for your enjoyment :');
    AddStatusLine('A');
    AddStatusLine('BPicture Converter 4');
    AddStatusLine('C');
    AddStatusLine('FCreated in 2018 for the demo Unboxed');
    AddStatusLine('F');
    AddStatusLine('GBonzai - More than just a tree');
    AddStatusLine('F');
    AddStatusLine('F');
    AddStatusLine('FWritten in Delphi 7 by Walt of Bonzai using');
    AddStatusLine('FTGIFImage by Anders Melander and Finn Tolderlund.');
    AddStatusLine('FTesting and improvement ideas by Fox, Dize and Trap.');
    AddStatusLine('F');
    AddStatusLine('GVersion 4.0.0.0, December 2018');
    AddStatusLine('F');
    First:=False;
  End;
  Form4.Color:=$c0ffff;
End;

procedure TForm4.FormResize(Sender: TObject);
begin
  StatusList.Width:=ClientWidth-24;
  StatusList.Repaint;
end;

procedure TForm4.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=Application.Terminated;
  If Not CanClose Then Form1.BringToFront;
end;

procedure TForm4.StatusListDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);

var l                : String;
    y                : Integer;
    r                : Integer;
    x                : Integer;
    Focus            : Boolean;

begin
  l:=StatusList.Items[Index];
  StatusList.Canvas.Brush.Style:=bsSolid;
  StatusList.Canvas.Brush.Color:=0;

  Focus:=(odFocused In State);

  If l[1]='B' Then Begin
    StatusList.Canvas.Brush.Color:=$d66470;
    StatusList.Canvas.Font.Color:=$ffffff;
  End;
  If l[1]='D' Then Begin
    StatusList.Canvas.Brush.Color:=0;
    StatusList.Canvas.Font.Color:=$80ff80;
    If Focus Then StatusList.Canvas.Brush.Color:=$008000;
  End;
  If l[1]='E' Then Begin
    StatusList.Canvas.Brush.Color:=$000080;
    StatusList.Canvas.Font.Color:=$c0c0ff;
    If Focus Then Begin
      StatusList.Canvas.Brush.Color:=$0000c0;
      StatusList.Canvas.Font.Color:=$ffffff;
    End;
    StatusError:=True;
    Form4.Color:=$8080ff;
  End;
  If l[1]='F' Then StatusList.Canvas.Font.Color:=$c0ffff;
  If l[1]='G' Then StatusList.Canvas.Font.Color:=$cfffcf;
  StatusList.Canvas.FillRect(Rect);

  If Length(l)>1 Then Begin
    x:=12;
    If l[1] In ['B', 'F', 'G'] Then x:=(Rect.Right-Rect.Left-StatusList.Canvas.TextWidth(Copy(l, 2, 1000))) Div 2;
    StatusList.Canvas.TextOut(Rect.Left+x, Rect.Top, Copy(l, 2, 1000));
  End;

  If l[1] In ['A', 'C'] Then Begin
    r:=(Rect.Bottom-Rect.Top) Div 7;

    For y:=0 To (r*3)-1 Do Begin
      StatusList.Canvas.Pen.Color:=$C1B76E;
      If l[1]='C' Then StatusList.Canvas.Pen.Color:=$992733;
      If (y Div r)=1 Then StatusList.Canvas.Pen.Color:=$d66470;

      If l[1]='A' Then Begin
        StatusList.Canvas.MoveTo(Rect.Left, Rect.Bottom-1-y);
        StatusList.Canvas.LineTo(Rect.Right, Rect.Bottom-1-y);
      End;
      If l[1]='C' Then Begin
        StatusList.Canvas.MoveTo(Rect.Left, Rect.Top+y);
        StatusList.Canvas.LineTo(Rect.Right, Rect.Top+y);
      End;
    End;
  End;

  StatusList.Canvas.Pen.Color:=0;
  If Focus Then StatusList.Canvas.Pen.Color:=$c0c0c0;
  StatusList.Canvas.MoveTo(Rect.Left, Rect.Top);
  StatusList.Canvas.LineTo(Rect.Left, Rect.Bottom);
  If Focus Then StatusList.Canvas.Pen.Color:=$909090;
  StatusList.Canvas.MoveTo(Rect.Left+1, Rect.Top);
  StatusList.Canvas.LineTo(Rect.Left+1, Rect.Bottom);
  StatusList.Canvas.MoveTo(Rect.Right-1, Rect.Top);
  StatusList.Canvas.LineTo(Rect.Right-1, Rect.Bottom);
  StatusList.Canvas.MoveTo(Rect.Right-2, Rect.Top);
  StatusList.Canvas.LineTo(Rect.Right-2, Rect.Bottom);

  If Focus Then StatusList.Canvas.DrawFocusRect(Rect);
end;

procedure TForm4.StatusListClick(Sender: TObject);
Var l : String;
    u : Integer;

begin
  If StatusList.ItemIndex>=0 Then Begin
    l:=Statuslist.Items[Statuslist.Itemindex];
    ErrorShow:=False;
    If l[1]='E' Then Begin
      If Pos(' - ', l)>0 Then Begin
        If Pos(' : ', l)>0 Then Begin
          Delete(l, 1, 1);
          Delete(l, Pos(' : ', l), 1000);
          l:=Trim(l);
          Val(Copy(l, 1, Pos(',', l)-1), ERLeft, u);
          Delete(l, 1, Pos(',', l));
          Val(Copy(l, 1, Pos(',', l)-1), ERTop, u);
          Delete(l, 1, Pos(' - ', l)+2);
          Val(Copy(l, 1, Pos(',', l)-1), ERRight, u);
          Delete(l, 1, Pos(',', l));
          Val(l, ERBottom, u);
          ErrorShow:=True;
        End;
      End;
    End;
  End;
end;

end.

